

#if !defined(COCO_PARSER_H__)
#define COCO_PARSER_H__

#include "../mod_ndb.h"


#include "Scanner.h"
char *JSON_string(ap_pool *, JSON::Token *);


namespace JSON {


class Errors {
public:
	int count;			// number of errors detected

	Errors();
	void SynErr(int line, int col, int n);
	void Error(int line, int col, const wchar_t *s);
	void Warning(int line, int col, const wchar_t *s);
	void Warning(const wchar_t *s);
	void Exception(const wchar_t *s);

}; // Errors

class Parser {
private:
	enum {
		_EOF=0,
		_string=1,
		_number=2,
	};
	int maxT;

	Token *dummyToken;
	int errDist;
	int minErrDist;

	void SynErr(int n);
	void Get();
	void Expect(int n);
	bool StartOf(int s);
	void ExpectWeak(int n, int follow);
	bool WeakSeparator(int n, int syFol, int repFol);

public:
	Scanner *scanner;
	Errors  *errors;

	Token *t;			// last recognized token
	Token *la;			// lookahead token

ap_pool *pool;
apr_table_t *tabl;
char *key, *val;  

  


	Parser(Scanner *scanner);
	~Parser();
	void SemErr(const wchar_t* msg);

	void JSON();
	void object();
	void array();
	void pair();
	void value();

	void Parse();

}; // end Parser

} // namespace


#endif // !defined(COCO_PARSER_H__)

